--//////////////////////////////////////
--// VHDL Code generated by SDDesigner
--// 15.02.2008 14:04:01
--//////////////////////////////////////

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.ALL;


ENTITY traffic_light IS
  PORT(
       clk : IN STD_LOGIC;
       nrst : IN STD_LOGIC;
       en : IN STD_LOGIC;
       red_out : OUT STD_LOGIC;
       green_out : OUT STD_LOGIC;
       yellow_out : OUT STD_LOGIC;
       cntr_val : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
      );
END;


ARCHITECTURE sd OF traffic_light IS
  -- Type declaration
     ATTRIBUTE ENUM_ENCODING: STRING;
     TYPE STATE_TYPE IS (red, yellow, green);
     ATTRIBUTE ENUM_ENCODING OF STATE_TYPE: TYPE IS "00 01 10";

  -- Constants
     CONSTANT CSIZE : INTEGER := 5;

  -- Registers
     SIGNAL state_name: STATE_TYPE;
     SIGNAL cntr : STD_LOGIC_VECTOR ((CSIZE-1) DOWNTO 0);

BEGIN
  --Combinatorical actions
    PROCESS(state_name, en, cntr)
    BEGIN
      red_out <= '0';
      green_out <= '0';
      yellow_out <= '0';
      cntr_val <= cntr;
      CASE state_name IS
        WHEN red =>
            red_out<='1';
        WHEN yellow =>
            yellow_out<='1';
        WHEN green =>
            green_out<='1';
      END CASE;
    END PROCESS;

  --FF actions
    PROCESS(nrst, clk)
    BEGIN
      IF (nrst = '0') THEN
        cntr <= "11001";
        state_name <= red;
      ELSIF (clk = '1') AND clk'EVENT THEN
        CASE state_name IS
          WHEN red =>
            IF (en='0') THEN
              cntr<="11001";
              state_name <= red;
            ELSIF (cntr=0) THEN
              cntr<="01111";
              state_name <= green;
            ELSE
              cntr<=cntr-1;
              state_name <= red;
            END IF;
          WHEN yellow =>
            IF (cntr=0) THEN
              cntr<="11001";
              state_name <= red;
            ELSE
              cntr<=cntr-1;
              state_name <= yellow;
            END IF;
          WHEN green =>
            IF (cntr=0) THEN
              cntr<="00010";
              state_name <= yellow;
            ELSE
              cntr<=cntr-1;
              state_name <= green;
            END IF;
        END CASE;
      END IF;
    END PROCESS;

END sd;
