LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY traffic_light_tb IS
END;

ARCHITECTURE tb OF traffic_light_tb IS

  CONSTANT sim_cyc: time := 100 ns;

  SIGNAL tb_clk: std_logic;
  SIGNAL tb_nrst: std_logic;
  SIGNAL tb_en: std_logic;
  SIGNAL tb_green_out: std_logic;
  SIGNAL tb_yellow_out: std_logic;
  SIGNAL tb_red_out: std_logic;
  SIGNAL tb_cntr_val: std_logic_vector(4 DOWNTO 0);

  COMPONENT traffic_light
    PORT(
      clk: IN std_logic;
      nrst: IN std_logic;
      en: IN std_logic;
      green_out: OUT std_logic;
      yellow_out: OUT std_logic;
      red_out: OUT std_logic;
      cntr_val: OUT std_logic_vector(4 DOWNTO 0));
  END COMPONENT;

BEGIN

  dut: traffic_light PORT MAP(tb_clk, tb_nrst, tb_en, tb_green_out, tb_yellow_out, tb_red_out, tb_cntr_val);

  PROCESS
  BEGIN
    tb_clk <= '0';
    WAIT FOR (sim_cyc - 1 ns);
    WHILE true LOOP
      tb_clk <= NOT tb_clk;
      WAIT FOR (sim_cyc / 2);
    END LOOP;
  END PROCESS;

  PROCESS
  BEGIN
    tb_nrst <= '0';
    tb_en <= '1';
    WAIT FOR (sim_cyc * 2);
    tb_nrst <= '1';
    WAIT FOR (sim_cyc * 50);
    tb_en <= '0';
    WAIT;
  END PROCESS;

END tb;
